package org.infinispan.query.remote.impl;

import java.util.Arrays;
import java.util.Collections;
import javax.annotation.Generated;

import org.infinispan.factories.impl.ComponentAccessor;
import org.infinispan.factories.impl.ModuleMetadataBuilder;
import org.infinispan.factories.impl.MBeanMetadata;
import org.infinispan.factories.impl.MBeanMetadata.AttributeMetadata;
import org.infinispan.factories.impl.MBeanMetadata.OperationMetadata;
import org.infinispan.factories.impl.MBeanMetadata.OperationParameterMetadata;
import org.infinispan.factories.impl.WireContext;
import org.infinispan.lifecycle.ModuleLifecycle;

/**
 * @private 
 */
@Generated(value = "org.infinispan.component.processor.Generator", date = "2021-01-18T13:31:53.789330Z")
public final class RemoteQueryServerPackageImpl {
   public static void registerMetadata(ModuleMetadataBuilder.ModuleBuilder builder) {
//start org.infinispan.query.remote.impl.ProtobufRemoteQueryManager
      builder.registerComponentAccessor("org.infinispan.query.remote.impl.ProtobufRemoteQueryManager",
         Collections.emptyList(),
         new ComponentAccessor<ProtobufRemoteQueryManager>("org.infinispan.query.remote.impl.ProtobufRemoteQueryManager",
            1, false, "org.infinispan.query.remote.impl.BaseRemoteQueryManager",
            Collections.emptyList()));

//start org.infinispan.query.remote.impl.ProtobufMetadataManagerImpl
      builder.registerComponentAccessor("org.infinispan.query.remote.impl.ProtobufMetadataManagerImpl",
         Collections.emptyList(),
         new ComponentAccessor<ProtobufMetadataManagerImpl>("org.infinispan.query.remote.impl.ProtobufMetadataManagerImpl",
            0, false, null,
            Arrays.asList("org.infinispan.manager.EmbeddedCacheManager", "org.infinispan.registry.InternalCacheRegistry", "org.infinispan.marshall.protostream.impl.SerializationContextRegistry")) {
         protected void wire(ProtobufMetadataManagerImpl instance, WireContext context, boolean start) {
            instance.cacheManager = context.get("org.infinispan.manager.EmbeddedCacheManager", org.infinispan.manager.EmbeddedCacheManager.class, start);
            instance.internalCacheRegistry = context.get("org.infinispan.registry.InternalCacheRegistry", org.infinispan.registry.InternalCacheRegistry.class, start);
            instance.serializationContextRegistry = context.get("org.infinispan.marshall.protostream.impl.SerializationContextRegistry", org.infinispan.marshall.protostream.impl.SerializationContextRegistry.class, start);
         }

         protected void start(ProtobufMetadataManagerImpl instance) throws Exception {
            instance.start();
         }

      });

      builder.registerMBeanMetadata("org.infinispan.query.remote.impl.ProtobufMetadataManagerImpl",
         MBeanMetadata.of("ProtobufMetadataManager", "Component that acts as a manager and persistent container for Protocol Buffers message type definitions in the scope of a CacheManger.", null,
            new AttributeMetadata("protofileNames", "The names of all Protobuf files", false, true, "java.lang.String[]", false, null, null),
            new AttributeMetadata("filesWithErrors", "The names of the files that have errors, if any", false, true, "java.lang.String[]", false, null, null),
            new OperationMetadata("registerProtofile", "", "Registers a Protobuf definition file", "void",
               new OperationParameterMetadata("fileName", "java.lang.String", "the name of the .proto file"),
               new OperationParameterMetadata("contents", "java.lang.String", "contents of the file")
            ),
            new OperationMetadata("registerProtofiles", "", "Registers multiple Protobuf definition files", "void",
               new OperationParameterMetadata("fileNames", "java.lang.String[]", "names of the protofiles"),
               new OperationParameterMetadata("fileContents", "java.lang.String[]", "content of the files")
            ),
            new OperationMetadata("unregisterProtofile", "", "Unregisters a Protobuf definition files", "void",
               new OperationParameterMetadata("fileName", "java.lang.String", "the name of the .proto file")
            ),
            new OperationMetadata("unregisterProtofiles", "", "Unregisters multiple Protobuf definition files", "void",
               new OperationParameterMetadata("fileNames", "java.lang.String[]", "names of the protofiles")
            ),
            new OperationMetadata("getProtofile", "", "Get the contents of a protobuf definition file", "java.lang.String",
               new OperationParameterMetadata("fileName", "java.lang.String", "the name of the .proto file")
            ),
            new OperationMetadata("getFileErrors", "", "Obtains the errors associated with a protobuf definition file", "java.lang.String",
               new OperationParameterMetadata("fileName", "java.lang.String", "the name of the .proto file")
            )
      ));

//start org.infinispan.query.remote.impl.BaseRemoteQueryManager
      builder.registerComponentAccessor("org.infinispan.query.remote.impl.BaseRemoteQueryManager",
         Collections.emptyList(),
         new ComponentAccessor<BaseRemoteQueryManager>("org.infinispan.query.remote.impl.BaseRemoteQueryManager",
            1, false, null,
            Arrays.asList("org.infinispan.marshall.core.EncoderRegistry")) {
         protected void wire(BaseRemoteQueryManager instance, WireContext context, boolean start) {
            instance.encoderRegistry = context.get("org.infinispan.marshall.core.EncoderRegistry", org.infinispan.marshall.core.EncoderRegistry.class, start);
         }

      });

//start org.infinispan.query.remote.impl.ObjectRemoteQueryManager
      builder.registerComponentAccessor("org.infinispan.query.remote.impl.ObjectRemoteQueryManager",
         Collections.emptyList(),
         new ComponentAccessor<ObjectRemoteQueryManager>("org.infinispan.query.remote.impl.ObjectRemoteQueryManager",
            1, false, "org.infinispan.query.remote.impl.BaseRemoteQueryManager",
            Collections.emptyList()));

//start org.infinispan.query.remote.impl.ProtobufMetadataManagerInterceptor
      builder.registerComponentAccessor("org.infinispan.query.remote.impl.ProtobufMetadataManagerInterceptor",
         Collections.emptyList(),
         new ComponentAccessor<ProtobufMetadataManagerInterceptor>("org.infinispan.query.remote.impl.ProtobufMetadataManagerInterceptor",
            1, false, "org.infinispan.interceptors.BaseCustomAsyncInterceptor",
            Arrays.asList("org.infinispan.commands.CommandsFactory", "org.infinispan.distribution.ch.KeyPartitioner", "org.infinispan.query.remote.ProtobufMetadataManager", "org.infinispan.marshall.protostream.impl.SerializationContextRegistry")) {
         protected void wire(ProtobufMetadataManagerInterceptor instance, WireContext context, boolean start) {
            instance.init(
               context.get("org.infinispan.commands.CommandsFactory", org.infinispan.commands.CommandsFactory.class, start),               context.getLazy("org.infinispan.interceptors.AsyncInterceptorChain", org.infinispan.interceptors.AsyncInterceptorChain.class, start),               context.get("org.infinispan.distribution.ch.KeyPartitioner", org.infinispan.distribution.ch.KeyPartitioner.class, start),               context.get("org.infinispan.query.remote.ProtobufMetadataManager", org.infinispan.query.remote.ProtobufMetadataManager.class, start),               context.get("org.infinispan.marshall.protostream.impl.SerializationContextRegistry", org.infinispan.marshall.protostream.impl.SerializationContextRegistry.class, start));
         }

      });

//end
   }
}
